elements = []


class Point:
    number: int
    signal: int

    def __init__(self, number, initial_signal):
        self.number = number
        self.signal = initial_signal

    def set_signal(self, new_signal: int):
        self.signal = new_signal


class Not:
    input: int
    output: int

    def __init__(self, input1, output):
        self.input = input1
        self.output = output

    def tick(self):
        input_signal = None
        output_entity = None
        for el in elements:
            if el.__class__ == Point:
                if el.number == self.input:
                    input_signal = el.signal
                if el.number == self.output:
                    output_entity = el
        # print(f"\n#NOT setting at {output_entity.number}:\n"
        #       "#from: " + str(output_entity.signal) + ",\n"
        #                                              "#to: " + str(int(not bool(input_signal))))
        output_entity.set_signal(int(not bool(input_signal)))


class And:
    input1: int
    input2: int
    output: int

    def __init__(self, input1, input2, output):
        self.input1 = input1
        self.input2 = input2
        self.output = output

    def tick(self):
        input1_signal = None
        input2_signal = None
        output_entity = None
        for el in elements:
            if el.__class__ == Point:
                if el.number == self.input1:
                    input1_signal = el.signal
                if el.number == self.input2:
                    input2_signal = el.signal
                if el.number == self.output:
                    output_entity = el
        # print(f"\n#AND setting at {output_entity.number}:\n"
        #       "#from: " + str(output_entity.signal) + ",\n"
        #                                              "#to: " + str(int(bool(input1_signal) and bool(input2_signal))))
        output_entity.set_signal(int(bool(input1_signal) and bool(input2_signal)))


n = int(input())
task_target = None
task_time = None
for _ in range(n):
    ints = list(map(int, input().split()))
    if ints[0] == 0:
        elements.append(Point(ints[1], ints[2]))
    if ints[0] == 1:
        elements.append(Not(ints[1], ints[2]))
    if ints[0] == 2:
        elements.append(And(ints[1], ints[2], ints[3]))
    if ints[0] == 3:
        task_target = ints[1]
        task_time = ints[2]


def tick():
    for el in elements:
        if el.__class__ == And or el.__class__ == Not:
            el.tick()


target = None

for el1 in elements:
    if (el1.__class__ == Point) and el1.number == task_target:
        target = el1

counter = 0

for _ in range(task_time):
    if counter >= len(elements):
        counter = 0
    if elements[counter].__class__ == And or elements[counter].__class__ == Not:
        elements[counter].tick()
    else:
        while elements[counter].__class__ != And and elements[counter].__class__ != Not:
            counter += 1
            if counter >= len(elements):
                counter = 0
        elements[counter].tick()
    print(target.signal)
